// Code generated by __generator__/builtin_functions.go; DO NOT EDIT.

package context

import (
	"github.com/ysugimoto/falco/types"
)

type Functions map[string]*FunctionSpec

type FunctionSpec struct {
	Items map[string]*FunctionSpec
	Value *BuiltinFunction
}

type BuiltinFunction struct {
	Arguments [][]types.Type
	Return    types.Type
	Extra     func(c *Context, name string) interface{}
	Scopes    int
	Reference string
}

func builtinFunctions() Functions {
	return Functions{
		"accept": &FunctionSpec{
			Items: map[string]*FunctionSpec{
				"charset_lookup": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.StringType, types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/content-negotiation/accept-charset-lookup/",
					},
				},
				"encoding_lookup": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.StringType, types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/content-negotiation/accept-encoding-lookup/",
					},
				},
				"language_filter_basic": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.StringType, types.StringType, types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/content-negotiation/accept-language-filter-basic/",
					},
				},
				"language_lookup": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.StringType, types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/content-negotiation/accept-language-lookup/",
					},
				},
				"media_lookup": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.StringType, types.StringType, types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/content-negotiation/accept-media-lookup/",
					},
				},
			},
		},
		"addr": &FunctionSpec{
			Items: map[string]*FunctionSpec{
				"extract_bits": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.IntegerType,
						Arguments: [][]types.Type{
							[]types.Type{types.IPType, types.IntegerType, types.IntegerType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/miscellaneous/addr-extract-bits/",
					},
				},
				"is_ipv4": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.BoolType,
						Arguments: [][]types.Type{
							[]types.Type{types.IPType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/miscellaneous/addr-is-ipv4/",
					},
				},
				"is_ipv6": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.BoolType,
						Arguments: [][]types.Type{
							[]types.Type{types.IPType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/miscellaneous/addr-is-ipv6/",
					},
				},
			},
		},
		"bin": &FunctionSpec{
			Items: map[string]*FunctionSpec{
				"base64_to_hex": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/cryptographic/bin-base64-to-hex/",
					},
				},
				"hex_to_base64": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/cryptographic/bin-hex-to-base64/",
					},
				},
			},
		},
		"boltsort": &FunctionSpec{
			Items: map[string]*FunctionSpec{
				"sort": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/query-string/boltsort-sort/",
					},
				},
			},
		},
		"crypto": &FunctionSpec{
			Items: map[string]*FunctionSpec{
				"decrypt_base64": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.IDType, types.IDType, types.IDType, types.StringType, types.StringType, types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/cryptographic/crypto-decrypt-base64/",
					},
				},
				"decrypt_hex": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.IDType, types.IDType, types.IDType, types.StringType, types.StringType, types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/cryptographic/crypto-decrypt-hex/",
					},
				},
				"encrypt_base64": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.IDType, types.IDType, types.IDType, types.StringType, types.StringType, types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/cryptographic/crypto-encrypt-base64/",
					},
				},
				"encrypt_hex": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.IDType, types.IDType, types.IDType, types.StringType, types.StringType, types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/cryptographic/crypto-encrypt-hex/",
					},
				},
			},
		},
		"cstr_escape": &FunctionSpec{
			Items: map[string]*FunctionSpec{},
			Value: &BuiltinFunction{
				Return: types.StringType,
				Arguments: [][]types.Type{
					[]types.Type{types.StringType},
				},
				Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
				Reference: "https://developer.fastly.com/reference/vcl/functions/strings/cstr-escape/",
			},
		},
		"digest": &FunctionSpec{
			Items: map[string]*FunctionSpec{
				"awsv4_hmac": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.StringType, types.StringType, types.StringType, types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/cryptographic/digest-awsv4-hmac/",
					},
				},
				"base64": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/cryptographic/digest-base64/",
					},
				},
				"base64_decode": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/cryptographic/digest-base64-decode/",
					},
				},
				"base64url": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/cryptographic/digest-base64url/",
					},
				},
				"base64url_decode": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/cryptographic/digest-base64url-decode/",
					},
				},
				"base64url_nopad": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/cryptographic/digest-base64url-nopad/",
					},
				},
				"base64url_nopad_decode": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/cryptographic/digest-base64url-nopad-decode/",
					},
				},
				"hash_crc32": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/cryptographic/digest-hash-crc32/",
					},
				},
				"hash_crc32b": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/cryptographic/digest-hash-crc32b/",
					},
				},
				"hash_md5": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/cryptographic/digest-hash-md5/",
					},
				},
				"hash_sha1": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/cryptographic/digest-hash-sha1/",
					},
				},
				"hash_sha1_from_base64": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/cryptographic/digest-hash-sha1-from-base64/",
					},
				},
				"hash_sha224": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/cryptographic/digest-hash-sha224/",
					},
				},
				"hash_sha256": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/cryptographic/digest-hash-sha256/",
					},
				},
				"hash_sha256_from_base64": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/cryptographic/digest-hash-sha256-from-base64/",
					},
				},
				"hash_sha384": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/cryptographic/digest-hash-sha384/",
					},
				},
				"hash_sha512": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/cryptographic/digest-hash-sha512/",
					},
				},
				"hash_sha512_from_base64": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/cryptographic/digest-hash-sha512-from-base64/",
					},
				},
				"hmac_md5": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/cryptographic/digest-hmac-md5/",
					},
				},
				"hmac_md5_base64": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/cryptographic/digest-hmac-md5-base64/",
					},
				},
				"hmac_sha1": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/cryptographic/digest-hmac-sha1/",
					},
				},
				"hmac_sha1_base64": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/cryptographic/digest-hmac-sha1-base64/",
					},
				},
				"hmac_sha256": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/cryptographic/digest-hmac-sha256/",
					},
				},
				"hmac_sha256_base64": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/cryptographic/digest-hmac-sha256-base64/",
					},
				},
				"hmac_sha512": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/cryptographic/digest-hmac-sha512/",
					},
				},
				"hmac_sha512_base64": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/cryptographic/digest-hmac-sha512-base64/",
					},
				},
				"rsa_verify": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.BoolType,
						Arguments: [][]types.Type{
							[]types.Type{types.IDType, types.StringType, types.StringType, types.StringType, types.IDType},
							[]types.Type{types.IDType, types.StringType, types.StringType, types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/cryptographic/digest-rsa-verify/",
					},
				},
				"secure_is_equal": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.BoolType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/cryptographic/digest-secure-is-equal/",
					},
				},
				"time_hmac_md5": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.IntegerType, types.IntegerType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/cryptographic/digest-time-hmac-md5/",
					},
				},
				"time_hmac_sha1": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.IntegerType, types.IntegerType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/cryptographic/digest-time-hmac-sha1/",
					},
				},
				"time_hmac_sha256": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.IntegerType, types.IntegerType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/cryptographic/digest-time-hmac-sha256/",
					},
				},
				"time_hmac_sha512": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.IntegerType, types.IntegerType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/cryptographic/digest-time-hmac-sha512/",
					},
				},
			},
		},
		"fastly": &FunctionSpec{
			Items: map[string]*FunctionSpec{
				"hash": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.IntegerType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.IntegerType, types.IntegerType, types.IntegerType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/miscellaneous/fastly-hash/",
					},
				},
			},
		},
		"h2": &FunctionSpec{
			Items: map[string]*FunctionSpec{
				"disable_header_compression": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Arguments: [][]types.Type{
							[]types.Type{},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/tls-and-http/h2-disable-header-compression/",
					},
				},
				"push": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/tls-and-http/h2-push/",
					},
				},
			},
		},
		"http_status_matches": &FunctionSpec{
			Items: map[string]*FunctionSpec{},
			Value: &BuiltinFunction{
				Return: types.BoolType,
				Arguments: [][]types.Type{
					[]types.Type{types.IntegerType, types.StringType},
				},
				Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
				Reference: "https://developer.fastly.com/reference/vcl/functions/miscellaneous/http-status-matches/",
			},
		},
		"json": &FunctionSpec{
			Items: map[string]*FunctionSpec{
				"escape": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/strings/json-escape/",
					},
				},
			},
		},
		"math": &FunctionSpec{
			Items: map[string]*FunctionSpec{
				"acos": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.FloatType,
						Arguments: [][]types.Type{
							[]types.Type{types.FloatType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/math-trig/math-acos/",
					},
				},
				"acosh": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.FloatType,
						Arguments: [][]types.Type{
							[]types.Type{types.FloatType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/math-trig/math-acosh/",
					},
				},
				"asin": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.FloatType,
						Arguments: [][]types.Type{
							[]types.Type{types.FloatType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/math-trig/math-asin/",
					},
				},
				"asinh": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.FloatType,
						Arguments: [][]types.Type{
							[]types.Type{types.FloatType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/math-trig/math-asinh/",
					},
				},
				"atan": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.FloatType,
						Arguments: [][]types.Type{
							[]types.Type{types.FloatType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/math-trig/math-atan/",
					},
				},
				"atan2": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.FloatType,
						Arguments: [][]types.Type{
							[]types.Type{types.FloatType, types.FloatType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/math-trig/math-atan2/",
					},
				},
				"atanh": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.FloatType,
						Arguments: [][]types.Type{
							[]types.Type{types.FloatType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/math-trig/math-atanh/",
					},
				},
				"ceil": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.FloatType,
						Arguments: [][]types.Type{
							[]types.Type{types.FloatType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/math-rounding/math-ceil/",
					},
				},
				"cos": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.FloatType,
						Arguments: [][]types.Type{
							[]types.Type{types.FloatType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/math-trig/math-cos/",
					},
				},
				"cosh": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.FloatType,
						Arguments: [][]types.Type{
							[]types.Type{types.FloatType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/math-trig/math-cosh/",
					},
				},
				"exp": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.FloatType,
						Arguments: [][]types.Type{
							[]types.Type{types.FloatType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/math-logexp/math-exp/",
					},
				},
				"exp2": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.FloatType,
						Arguments: [][]types.Type{
							[]types.Type{types.FloatType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/math-logexp/math-exp2/",
					},
				},
				"floor": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.FloatType,
						Arguments: [][]types.Type{
							[]types.Type{types.FloatType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/math-rounding/math-floor/",
					},
				},
				"is_finite": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.BoolType,
						Arguments: [][]types.Type{
							[]types.Type{types.FloatType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/floating-point-classifications/math-is-finite/",
					},
				},
				"is_infinite": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.BoolType,
						Arguments: [][]types.Type{
							[]types.Type{types.FloatType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/floating-point-classifications/math-is-infinite/",
					},
				},
				"is_nan": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.BoolType,
						Arguments: [][]types.Type{
							[]types.Type{types.FloatType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/floating-point-classifications/math-is-nan/",
					},
				},
				"is_normal": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.BoolType,
						Arguments: [][]types.Type{
							[]types.Type{types.FloatType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/floating-point-classifications/math-is-normal/",
					},
				},
				"is_subnormal": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.BoolType,
						Arguments: [][]types.Type{
							[]types.Type{types.FloatType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/floating-point-classifications/math-is-subnormal/",
					},
				},
				"log": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.FloatType,
						Arguments: [][]types.Type{
							[]types.Type{types.FloatType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/math-logexp/math-log/",
					},
				},
				"log10": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.FloatType,
						Arguments: [][]types.Type{
							[]types.Type{types.FloatType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/math-logexp/math-log10/",
					},
				},
				"log2": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.FloatType,
						Arguments: [][]types.Type{
							[]types.Type{types.FloatType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/math-logexp/math-log2/",
					},
				},
				"round": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.FloatType,
						Arguments: [][]types.Type{
							[]types.Type{types.FloatType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/math-rounding/math-round/",
					},
				},
				"roundeven": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.FloatType,
						Arguments: [][]types.Type{
							[]types.Type{types.FloatType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/math-rounding/math-roundeven/",
					},
				},
				"roundhalfdown": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.FloatType,
						Arguments: [][]types.Type{
							[]types.Type{types.FloatType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/math-rounding/math-roundhalfdown/",
					},
				},
				"roundhalfup": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.FloatType,
						Arguments: [][]types.Type{
							[]types.Type{types.FloatType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/math-rounding/math-roundhalfup/",
					},
				},
				"sin": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.FloatType,
						Arguments: [][]types.Type{
							[]types.Type{types.FloatType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/math-trig/math-sin/",
					},
				},
				"sinh": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.FloatType,
						Arguments: [][]types.Type{
							[]types.Type{types.FloatType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/math-trig/math-sinh/",
					},
				},
				"sqrt": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.FloatType,
						Arguments: [][]types.Type{
							[]types.Type{types.FloatType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/math-trig/math-sqrt/",
					},
				},
				"tan": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.FloatType,
						Arguments: [][]types.Type{
							[]types.Type{types.FloatType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/math-trig/math-tan/",
					},
				},
				"tanh": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.FloatType,
						Arguments: [][]types.Type{
							[]types.Type{types.FloatType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/math-trig/math-tanh/",
					},
				},
				"trunc": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.FloatType,
						Arguments: [][]types.Type{
							[]types.Type{types.FloatType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/math-rounding/math-trunc/",
					},
				},
			},
		},
		"parse_time_delta": &FunctionSpec{
			Items: map[string]*FunctionSpec{},
			Value: &BuiltinFunction{
				Return: types.IntegerType,
				Arguments: [][]types.Type{
					[]types.Type{types.StringType},
				},
				Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
				Reference: "https://developer.fastly.com/reference/vcl/functions/date-and-time/parse-time-delta/",
			},
		},
		"querystring": &FunctionSpec{
			Items: map[string]*FunctionSpec{
				"add": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.StringType, types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/query-string/querystring-add/",
					},
				},
				"clean": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/query-string/querystring-clean/",
					},
				},
				"filter": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/query-string/querystring-filter/",
					},
				},
				"filter_except": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/query-string/querystring-filter-except/",
					},
				},
				"filtersep": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return:    types.StringType,
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/query-string/querystring-filtersep/",
					},
				},
				"get": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/query-string/querystring-get/",
					},
				},
				"globfilter": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/query-string/querystring-globfilter/",
					},
				},
				"globfilter_except": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/query-string/querystring-globfilter-except/",
					},
				},
				"regfilter": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/query-string/querystring-regfilter/",
					},
				},
				"regfilter_except": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/query-string/querystring-regfilter-except/",
					},
				},
				"remove": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/query-string/querystring-remove/",
					},
				},
				"set": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.StringType, types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/query-string/querystring-set/",
					},
				},
				"sort": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/query-string/querystring-sort/",
					},
				},
			},
		},
		"randombool": &FunctionSpec{
			Items: map[string]*FunctionSpec{},
			Value: &BuiltinFunction{
				Return: types.BoolType,
				Arguments: [][]types.Type{
					[]types.Type{types.IntegerType, types.IntegerType},
				},
				Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
				Reference: "https://developer.fastly.com/reference/vcl/functions/randomness/randombool/",
			},
		},
		"randombool_seeded": &FunctionSpec{
			Items: map[string]*FunctionSpec{},
			Value: &BuiltinFunction{
				Return: types.BoolType,
				Arguments: [][]types.Type{
					[]types.Type{types.IntegerType, types.IntegerType, types.IntegerType},
				},
				Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
				Reference: "https://developer.fastly.com/reference/vcl/functions/randomness/randombool-seeded/",
			},
		},
		"randomint": &FunctionSpec{
			Items: map[string]*FunctionSpec{},
			Value: &BuiltinFunction{
				Return: types.IntegerType,
				Arguments: [][]types.Type{
					[]types.Type{types.IntegerType, types.IntegerType},
				},
				Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
				Reference: "https://developer.fastly.com/reference/vcl/functions/randomness/randomint/",
			},
		},
		"randomint_seeded": &FunctionSpec{
			Items: map[string]*FunctionSpec{},
			Value: &BuiltinFunction{
				Return: types.IntegerType,
				Arguments: [][]types.Type{
					[]types.Type{types.IntegerType, types.IntegerType, types.IntegerType},
				},
				Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
				Reference: "https://developer.fastly.com/reference/vcl/functions/randomness/randomint-seeded/",
			},
		},
		"randomstr": &FunctionSpec{
			Items: map[string]*FunctionSpec{},
			Value: &BuiltinFunction{
				Return: types.StringType,
				Arguments: [][]types.Type{
					[]types.Type{types.IntegerType},
					[]types.Type{types.IntegerType, types.StringType},
				},
				Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
				Reference: "https://developer.fastly.com/reference/vcl/functions/randomness/randomstr/",
			},
		},
		"ratelimit": &FunctionSpec{
			Items: map[string]*FunctionSpec{
				"check_rate": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.BoolType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.IDType, types.IntegerType, types.IntegerType, types.IntegerType, types.IDType, types.RTimeType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/rate-limiting/ratelimit-check-rate/",
					},
				},
				"check_rates": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.BoolType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.IDType, types.IntegerType, types.IntegerType, types.IntegerType, types.IDType, types.IntegerType, types.IntegerType, types.IntegerType, types.IDType, types.RTimeType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/rate-limiting/ratelimit-check-rates/",
					},
				},
				"penaltybox_add": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Arguments: [][]types.Type{
							[]types.Type{types.IDType, types.StringType, types.RTimeType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/rate-limiting/ratelimit-penaltybox-add/",
					},
				},
				"penaltybox_has": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.BoolType,
						Arguments: [][]types.Type{
							[]types.Type{types.IDType, types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/rate-limiting/ratelimit-penaltybox-has/",
					},
				},
				"ratecounter_increment": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.IntegerType,
						Arguments: [][]types.Type{
							[]types.Type{types.IDType, types.StringType, types.IntegerType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/rate-limiting/ratelimit-ratecounter-increment/",
					},
				},
			},
		},
		"regsub": &FunctionSpec{
			Items: map[string]*FunctionSpec{},
			Value: &BuiltinFunction{
				Return: types.StringType,
				Arguments: [][]types.Type{
					[]types.Type{types.StringType, types.StringType, types.StringType},
				},
				Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
				Reference: "https://developer.fastly.com/reference/vcl/functions/strings/regsub/",
			},
		},
		"regsuball": &FunctionSpec{
			Items: map[string]*FunctionSpec{},
			Value: &BuiltinFunction{
				Return: types.StringType,
				Arguments: [][]types.Type{
					[]types.Type{types.StringType, types.StringType, types.StringType},
				},
				Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
				Reference: "https://developer.fastly.com/reference/vcl/functions/strings/regsuball/",
			},
		},
		"resp": &FunctionSpec{
			Items: map[string]*FunctionSpec{
				"tarpit": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.StringType},
							[]types.Type{types.StringType},
						},
						Scopes:    DELIVER,
						Reference: "https://developer.fastly.com/reference/vcl/functions/miscellaneous/resp-tarpit/",
					},
				},
			},
		},
		"setcookie": &FunctionSpec{
			Items: map[string]*FunctionSpec{
				"delete_by_name": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.BoolType,
						Arguments: [][]types.Type{
							[]types.Type{types.IDType, types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/miscellaneous/setcookie-delete-by-name/",
					},
				},
				"get_value_by_name": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.IDType, types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/miscellaneous/setcookie-get-value-by-name/",
					},
				},
			},
		},
		"std": &FunctionSpec{
			Items: map[string]*FunctionSpec{
				"anystr2ip": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.IPType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/strings/std-anystr2ip/",
					},
				},
				"atof": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.FloatType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/strings/std-atof/",
					},
				},
				"atoi": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.IntegerType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/strings/std-atoi/",
					},
				},
				"basename": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/strings/std-basename/",
					},
				},
				"collect": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Arguments: [][]types.Type{
							[]types.Type{types.IDType},
							[]types.Type{types.IDType, types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/miscellaneous/std-collect/",
					},
				},
				"count": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.IntegerType,
						Arguments: [][]types.Type{
							[]types.Type{types.IDType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/miscellaneous/std-count/",
					},
				},
				"dirname": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/strings/std-dirname/",
					},
				},
				"integer2time": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.TimeType,
						Arguments: [][]types.Type{
							[]types.Type{types.IntegerType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/date-and-time/std-integer2time/",
					},
				},
				"ip": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.IPType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/strings/std-ip/",
					},
				},
				"ip2str": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.IPType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/strings/std-ip2str/",
					},
				},
				"itoa": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.IntegerType, types.IntegerType},
							[]types.Type{types.IntegerType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/strings/std-itoa/",
					},
				},
				"itoa_charset": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.IntegerType, types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/strings/std-itoa-charset/",
					},
				},
				"prefixof": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.BoolType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/strings/std-prefixof/",
					},
				},
				"replace": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.StringType, types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/strings/std-replace/",
					},
				},
				"replace_prefix": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.StringType, types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/strings/std-replace-prefix/",
					},
				},
				"replace_suffix": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.StringType, types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/strings/std-replace-suffix/",
					},
				},
				"replaceall": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.StringType, types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/strings/std-replaceall/",
					},
				},
				"str2ip": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.IPType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/strings/std-str2ip/",
					},
				},
				"strlen": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.IntegerType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/strings/std-strlen/",
					},
				},
				"strpad": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.IntegerType, types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/strings/std-strpad/",
					},
				},
				"strrep": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.IntegerType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/strings/std-strrep/",
					},
				},
				"strrev": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/strings/std-strrev/",
					},
				},
				"strstr": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/strings/std-strstr/",
					},
				},
				"strtof": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.FloatType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.IntegerType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/strings/std-strtof/",
					},
				},
				"strtol": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.IntegerType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.IntegerType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/strings/std-strtol/",
					},
				},
				"suffixof": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.BoolType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/strings/std-suffixof/",
					},
				},
				"time": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.TimeType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.TimeType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/date-and-time/std-time/",
					},
				},
				"tolower": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/strings/std-tolower/",
					},
				},
				"toupper": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/strings/std-toupper/",
					},
				},
			},
		},
		"strftime": &FunctionSpec{
			Items: map[string]*FunctionSpec{},
			Value: &BuiltinFunction{
				Return: types.StringType,
				Arguments: [][]types.Type{
					[]types.Type{types.StringType, types.TimeType},
				},
				Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
				Reference: "https://developer.fastly.com/reference/vcl/functions/date-and-time/strftime/",
			},
		},
		"subfield": &FunctionSpec{
			Items: map[string]*FunctionSpec{},
			Value: &BuiltinFunction{
				Return: types.StringType,
				Arguments: [][]types.Type{
					[]types.Type{types.StringType, types.StringType, types.StringType},
					[]types.Type{types.StringType, types.StringType},
				},
				Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
				Reference: "https://developer.fastly.com/reference/vcl/functions/miscellaneous/subfield/",
			},
		},
		"substr": &FunctionSpec{
			Items: map[string]*FunctionSpec{},
			Value: &BuiltinFunction{
				Return: types.StringType,
				Arguments: [][]types.Type{
					[]types.Type{types.StringType, types.IntegerType, types.IntegerType},
					[]types.Type{types.StringType, types.IntegerType},
				},
				Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
				Reference: "https://developer.fastly.com/reference/vcl/functions/strings/substr/",
			},
		},
		"table": &FunctionSpec{
			Items: map[string]*FunctionSpec{
				"contains": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.BoolType,
						Arguments: [][]types.Type{
							[]types.Type{types.TableType, types.StringType},
						},
						Extra:     func(c *Context, name string) interface{} { return c.Tables[name] },
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/table/table-contains/",
					},
				},
				"lookup": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.TableType, types.StringType, types.StringType},
							[]types.Type{types.TableType, types.StringType},
						},
						Extra:     func(c *Context, name string) interface{} { return c.Tables[name] },
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/table/table-lookup/",
					},
				},
				"lookup_acl": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.AclType,
						Arguments: [][]types.Type{
							[]types.Type{types.TableType, types.StringType, types.AclType},
							[]types.Type{types.TableType, types.StringType},
						},
						Extra:     func(c *Context, name string) interface{} { return c.Tables[name] },
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/table/table-lookup-acl/",
					},
				},
				"lookup_backend": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.BackendType,
						Arguments: [][]types.Type{
							[]types.Type{types.TableType, types.StringType, types.BackendType},
							[]types.Type{types.TableType, types.StringType},
						},
						Extra:     func(c *Context, name string) interface{} { return c.Tables[name] },
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/table/table-lookup-backend/",
					},
				},
				"lookup_bool": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.BoolType,
						Arguments: [][]types.Type{
							[]types.Type{types.TableType, types.StringType, types.BoolType},
							[]types.Type{types.TableType, types.StringType},
						},
						Extra:     func(c *Context, name string) interface{} { return c.Tables[name] },
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/table/table-lookup-bool/",
					},
				},
				"lookup_float": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.FloatType,
						Arguments: [][]types.Type{
							[]types.Type{types.TableType, types.StringType, types.FloatType},
							[]types.Type{types.TableType, types.StringType},
						},
						Extra:     func(c *Context, name string) interface{} { return c.Tables[name] },
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/table/table-lookup-float/",
					},
				},
				"lookup_integer": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.IntegerType,
						Arguments: [][]types.Type{
							[]types.Type{types.TableType, types.StringType, types.IntegerType},
							[]types.Type{types.TableType, types.StringType},
						},
						Extra:     func(c *Context, name string) interface{} { return c.Tables[name] },
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/table/table-lookup-integer/",
					},
				},
				"lookup_ip": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.IPType,
						Arguments: [][]types.Type{
							[]types.Type{types.TableType, types.StringType, types.IPType},
							[]types.Type{types.TableType, types.StringType},
						},
						Extra:     func(c *Context, name string) interface{} { return c.Tables[name] },
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/table/table-lookup-ip/",
					},
				},
				"lookup_rtime": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.RTimeType,
						Arguments: [][]types.Type{
							[]types.Type{types.TableType, types.StringType, types.RTimeType},
							[]types.Type{types.TableType, types.StringType},
						},
						Extra:     func(c *Context, name string) interface{} { return c.Tables[name] },
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/table/table-lookup-rtime/",
					},
				},
			},
		},
		"time": &FunctionSpec{
			Items: map[string]*FunctionSpec{
				"add": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.TimeType,
						Arguments: [][]types.Type{
							[]types.Type{types.TimeType, types.RTimeType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/date-and-time/time-add/",
					},
				},
				"hex_to_time": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.TimeType,
						Arguments: [][]types.Type{
							[]types.Type{types.IntegerType, types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/date-and-time/time-hex-to-time/",
					},
				},
				"is_after": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.BoolType,
						Arguments: [][]types.Type{
							[]types.Type{types.TimeType, types.TimeType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/date-and-time/time-is-after/",
					},
				},
				"runits": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.RTimeType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/date-and-time/time-runits/",
					},
				},
				"sub": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.TimeType,
						Arguments: [][]types.Type{
							[]types.Type{types.TimeType, types.RTimeType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/date-and-time/time-sub/",
					},
				},
				"units": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.TimeType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/date-and-time/time-units/",
					},
				},
			},
		},
		"urldecode": &FunctionSpec{
			Items: map[string]*FunctionSpec{},
			Value: &BuiltinFunction{
				Return: types.StringType,
				Arguments: [][]types.Type{
					[]types.Type{types.StringType},
				},
				Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
				Reference: "https://developer.fastly.com/reference/vcl/functions/strings/urldecode/",
			},
		},
		"urlencode": &FunctionSpec{
			Items: map[string]*FunctionSpec{},
			Value: &BuiltinFunction{
				Return: types.StringType,
				Arguments: [][]types.Type{
					[]types.Type{types.StringType},
				},
				Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
				Reference: "https://developer.fastly.com/reference/vcl/functions/strings/urlencode/",
			},
		},
		"utf8": &FunctionSpec{
			Items: map[string]*FunctionSpec{
				"codepoint_count": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.IntegerType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/strings/utf8-codepoint-count/",
					},
				},
				"is_valid": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.BoolType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/strings/utf8-is-valid/",
					},
				},
				"strpad": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.IntegerType, types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/strings/utf8-strpad/",
					},
				},
				"substr": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.IntegerType, types.IntegerType},
							[]types.Type{types.StringType, types.IntegerType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/strings/utf8-substr/",
					},
				},
			},
		},
		"uuid": &FunctionSpec{
			Items: map[string]*FunctionSpec{
				"dns": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return:    types.StringType,
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/uuid/uuid-dns/",
					},
				},
				"is_valid": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.BoolType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/uuid/uuid-is-valid/",
					},
				},
				"is_version3": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.BoolType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/uuid/uuid-is-version3/",
					},
				},
				"is_version4": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.BoolType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/uuid/uuid-is-version4/",
					},
				},
				"is_version5": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.BoolType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/uuid/uuid-is-version5/",
					},
				},
				"oid": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return:    types.StringType,
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/uuid/uuid-oid/",
					},
				},
				"url": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return:    types.StringType,
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/uuid/uuid-url/",
					},
				},
				"version3": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/uuid/uuid-version3/",
					},
				},
				"version4": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return:    types.StringType,
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/uuid/uuid-version4/",
					},
				},
				"version5": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return: types.StringType,
						Arguments: [][]types.Type{
							[]types.Type{types.StringType, types.StringType},
						},
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/uuid/uuid-version5/",
					},
				},
				"x500": &FunctionSpec{
					Items: map[string]*FunctionSpec{},
					Value: &BuiltinFunction{
						Return:    types.StringType,
						Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
						Reference: "https://developer.fastly.com/reference/vcl/functions/uuid/uuid-x500/",
					},
				},
			},
		},
		"xml_escape": &FunctionSpec{
			Items: map[string]*FunctionSpec{},
			Value: &BuiltinFunction{
				Return: types.StringType,
				Arguments: [][]types.Type{
					[]types.Type{types.StringType},
				},
				Scopes:    RECV | HASH | HIT | MISS | PASS | FETCH | ERROR | DELIVER | LOG,
				Reference: "https://developer.fastly.com/reference/vcl/functions/strings/xml-escape/",
			},
		},
	}

}
